Support references with content defined inside <references/> block (<ref name=abc /> <references><ref name=abc>Content</ref></references>)
Closed, ResolvedPublic

Description

VE should support references with content defined inside <references/> block. This style is widely used on the Polish Wikipedia to keep the wikitext mostly readable.

  • 8< ---------

Some text.<ref name=abc />

<references><ref name=abc>Content</ref></references>

  • 8< ---------

Live example: https://pl.wikipedia.org/w/index.php?title=Wikipedysta:Matma_Rex/brudnopis&direction=next&oldid=37095835

And it would be really cool if it could also supports this (but I'm not holding my breath):

  • 8< ---------

Some text.{{r|abc}}

{{reflist|refs=<ref name=abc>Content</ref>}}

  • 8< ---------

About this feature on en.wp help pages: [[Help:Footnotes#Footnotes: list-defined references]]


Version: unspecified
Severity: major

bzimport set Reference to bz51741.
matmarex created this task.Via LegacyJul 20 2013, 10:53 AM
matmarex added a comment.Via ConduitJul 20 2013, 11:00 AM

This would require some help from the Parsoid side:

  • VE requires knowing the generated HTML for ref bodies, and Parsoid currently only provides these for inline refs with bodies (<ref name=asd>body</ref>), as (data-mw).html.body.
  • The simplest way to do this seems to be providing generated HTML for refs inside <references/> as an array of ref bodies inside <references/>'s data-mw.
jayvdb added a comment.Via ConduitJul 24 2013, 9:32 AM

When I try your sandbox, I can edit the references list using wikitext in the template dialog.

On German Wikipedia, this article is similar but has templates inside <references/>
https://de.wikipedia.org/wiki/This_Is_War?veaction=edit
It isnt editable with this notice repeating many times:

"This reference is defined in a template or other generated block, and for now can only be edited in source mode"
gerritbot added a comment.Via ConduitJul 25 2013, 5:14 PM

Change 75912 had a related patch set uploaded by Esanders:
[WIP] Ref in references support

https://gerrit.wikimedia.org/r/75912

jayvdb added a comment.Via ConduitJul 25 2013, 11:09 PM

On Parsoid topfail there are several dewp entries for <!-- comments --> within <references/> being moved around. I couldnt reproduce those bugs, probably because of selective serialization. If this is now editable, these dirty diffs may start happening in production. It would be good to test, but I suspect impact is quite low because I checked 20 featured articles and 10 good articles on dewp, and none had these comments within <references/>.

http://parsoid.wmflabs.org:8001/latestresult/de/Flugplatz_St._Michaelisdonn
http://parsoid.wmflabs.org:8001/latestresult/de/ARO_Heimtextilien

And here is one for whitespace within <references/>

http://parsoid.wmflabs.org:8001/latestresult/de/Trigonias

gerritbot added a comment.Via ConduitJul 30 2013, 9:53 PM

Change 75912 merged by jenkins-bot:
Ref in references support

https://gerrit.wikimedia.org/r/75912

Jdforrester-WMF added a comment.Via ConduitJul 30 2013, 10:09 PM

This is now merged and will get deployed today; however, to actually do what people want depends on a change in Parsoid that will get deployed tomorrow.

Add Comment

Column Prototype
This is a very early prototype of a persistent column. It is not expected to work yet, and leaving it open will activate other new features which will break things. Press "\" (backslash) on your keyboard to close it now.